job_name='NoTariff_pi4med_C1L1B4_d0510_05'

file_baseline = ['../Mat/', job_name, '_Benchmark.mat'];
file_sp = ['../Mat/', job_name, '_Planner.mat'];
file_nash = ['../Mat/', job_name, '_Nash.mat'];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% baseline
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load(file_baseline);
policylength = HH;

[err_0,ls_0,lsstar_0,li_0,listar_0,lr_0,lrstar_0,cs_0,csstar_0,ci_0,cistar_0,cr_0,crstar_0,chs_0,cfs_0,chsstar_0,cfsstar_0,chi_0,cfi_0,chistar_0,cfistar_0,chr_0,cfr_0,chrstar_0,cfrstar_0,...
    P_0,Pstar_0,ph_0,pfstar_0,S_0,Sstar_0,I_0,Istar_0,R_0,Rstar_0,T_0,Tstar_0,aggC_0,aggCstar_0,aggL_0,aggLstar_0,g_0,gstar_0,aggU_0,aggUstar_0] = ...
    getErr(n_vec,HH,policylength,beta,z,zstar,kappa,alpha,sigma,I0,Istar0,pop0,popstar0,pi1,pi2,pi3,pi4,pi5,pi6,pir,pid,phi,Uiss,Urss,Udeath,muh,muf,muhstar,mufstar);

muh_0 = zeros(HH,1);
muf_0 = zeros(HH,1);
muhstar_0 = zeros(HH,1);
mufstar_0 = zeros(HH,1);


deltaH_0 = (alpha.^sigma*((1+muh_0).*ph_0).^(-sigma))./...
    (alpha.^sigma*((1+muh_0).*ph_0).^(-(sigma-1)) +...
    (1-alpha).^sigma*((1+muf_0).*pfstar_0).^(-(sigma-1))).^(sigma/(sigma-1));
deltaF_0 = ((1-alpha).^sigma*((1+muf_0).*pfstar_0).^(-sigma))./...
    (alpha.^sigma*((1+muh_0).*ph_0).^(-(sigma-1)) +...
    (1-alpha).^sigma*((1+muf_0).*pfstar_0).^(-(sigma-1))).^(sigma/(sigma-1));
spending_0 = deltaH_0./(deltaH_0+deltaF_0);

deltaFstar_0 = (alpha.^sigma*((1+mufstar_0).*pfstar_0).^(-sigma))./...
    (alpha.^sigma*((1+mufstar_0).*pfstar_0).^(-(sigma-1)) +...
    (1-alpha)^sigma*((1+muhstar_0).*ph_0).^(-(sigma-1))).^(sigma/(sigma-1));
deltaHstar_0 = ((1-alpha).^sigma*((1+muhstar_0).*ph_0).^(-sigma))./...
    (alpha.^sigma*((1+mufstar_0).*pfstar_0).^(-(sigma-1)) +...
    (1-alpha)^sigma*((1+muhstar_0).*ph_0).^(-(sigma-1))).^(sigma/(sigma-1));
spendingstar_0 = deltaFstar_0./(deltaHstar_0+deltaFstar_0);

ur_0=log(cr_0)-kappa/2*lr_0.^2;
urstar_0=log(crstar_0)-kappa/2*lrstar_0.^2;
ui_0=log(ci_0)-kappa/2*li_0.^2;
uistar_0=log(cistar_0)-kappa/2*listar_0.^2;
us_0=log(cs_0)-kappa/2*ls_0.^2;
usstar_0=log(csstar_0)-kappa/2*lsstar_0.^2;
aggu_0=S_0.*us_0 + I_0.*ui_0 + R_0.*ur_0;
aggustar_0=Sstar_0.*usstar_0 + Istar_0.*uistar_0 + Rstar_0.*urstar_0;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% social planner
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
load(file_sp);

[err_sp,ls_sp,lsstar_sp,li_sp,listar_sp,lr_sp,lrstar_sp,cs_sp,csstar_sp,ci_sp,cistar_sp,cr_sp,crstar_sp,chs_sp,cfs_sp,chsstar_sp,cfsstar_sp,chi_sp,cfi_sp,chistar_sp,cfistar_sp,chr_sp,cfr_sp,chrstar_sp,cfrstar_sp,...
    P_sp,Pstar_sp,ph_sp,pfstar_sp,S_sp,Sstar_sp,I_sp,Istar_sp,R_sp,Rstar_sp,T_sp,Tstar_sp,aggC_sp,aggCstar_sp,aggL_sp,aggLstar_sp,g_sp,gstar_sp,aggU_sp,aggUstar_sp] = ...
    getErr(n_vec,HH,policylength,beta,z,zstar,kappa,alpha,sigma,I0,Istar0,pop0,popstar0,pi1,pi2,pi3,pi4,pi5,pi6,pir,pid,phi,Uiss,Urss,Udeath,muh,muf,muhstar,mufstar);

muh_sp = muh;
muf_sp = muf;
muhstar_sp = muhstar;
mufstar_sp = mufstar;

deltaH_sp = (alpha.^sigma*((1+muh_sp).*ph_sp).^(-sigma))./...
    (alpha.^sigma*((1+muh_sp).*ph_sp).^(-(sigma-1)) +...
    (1-alpha).^sigma*((1+muf_sp).*pfstar_sp).^(-(sigma-1))).^(sigma/(sigma-1));
deltaF_sp = ((1-alpha).^sigma*((1+muf_sp).*pfstar_sp).^(-sigma))./...
    (alpha.^sigma*((1+muh_sp).*ph_sp).^(-(sigma-1)) +...
    (1-alpha).^sigma*((1+muf_sp).*pfstar_sp).^(-(sigma-1))).^(sigma/(sigma-1));
spending_sp = deltaH_sp./(deltaH_sp+deltaF_sp);

deltaFstar_sp = (alpha.^sigma*((1+mufstar_sp).*pfstar_sp).^(-sigma))./...
    (alpha.^sigma*((1+mufstar_sp).*pfstar_sp).^(-(sigma-1)) +...
    (1-alpha)^sigma*((1+muhstar_sp).*ph_sp).^(-(sigma-1))).^(sigma/(sigma-1));
deltaHstar_sp = ((1-alpha).^sigma*((1+muhstar_sp).*ph_sp).^(-sigma))./...
    (alpha.^sigma*((1+mufstar_sp).*pfstar_sp).^(-(sigma-1)) +...
    (1-alpha)^sigma*((1+muhstar_sp).*ph_sp).^(-(sigma-1))).^(sigma/(sigma-1));
spendingstar_sp = deltaFstar_sp./(deltaHstar_sp+deltaFstar_sp);


ur_sp=log(cr_sp)-kappa/2*lr_sp.^2;
urstar_sp=log(crstar_sp)-kappa/2*lrstar_sp.^2;
ui_sp=log(ci_sp)-kappa/2*li_sp.^2;
uistar_sp=log(cistar_sp)-kappa/2*listar_sp.^2;
us_sp=log(cs_sp)-kappa/2*ls_sp.^2;
usstar_sp=log(csstar_sp)-kappa/2*lsstar_sp.^2;
aggu_sp=S_sp.*us_sp + I_sp.*ui_sp + R_sp.*ur_sp;
aggustar_sp=Sstar_sp.*usstar_sp + Istar_sp.*uistar_sp + Rstar_sp.*urstar_sp;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% nash
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
load(file_nash);

[err_nash,ls_nash,lsstar_nash,li_nash,listar_nash,lr_nash,lrstar_nash,cs_nash,csstar_nash,ci_nash,cistar_nash,cr_nash,crstar_nash,chs_nash,cfs_nash,chsstar_nash,cfsstar_nash,chi_nash,cfi_nash,chistar_nash,cfistar_nash,chr_nash,cfr_nash,chrstar_nash,cfrstar_nash,...
    P_nash,Pstar_nash,ph_nash,pfstar_nash,S_nash,Sstar_nash,I_nash,Istar_nash,R_nash,Rstar_nash,T_nash,Tstar_nash,aggC_nash,aggCstar_nash,aggL_nash,aggLstar_nash,g_nash,gstar_nash,aggU_nash,aggUstar_nash] = ...
    getErr(n_vec,HH,policylength, beta,z,zstar,kappa,alpha,sigma,I0,Istar0,pop0,popstar0,pi1,pi2,pi3,pi4,pi5,pi6,pir,pid,phi,Uiss,Urss,Udeath,muh,muf,muhstar,mufstar);

muh_nash = muh;
muf_nash = muf;
muhstar_nash = muhstar;
mufstar_nash = mufstar;


deltaH_nash = (alpha.^sigma*((1+muh_nash).*ph_nash).^(-sigma))./...
    (alpha.^sigma*((1+muh_nash).*ph_nash).^(-(sigma-1)) +...
    (1-alpha).^sigma*((1+muf_nash).*pfstar_nash).^(-(sigma-1))).^(sigma/(sigma-1));
deltaF_nash = ((1-alpha).^sigma*((1+muf_nash).*pfstar_nash).^(-sigma))./...
    (alpha.^sigma*((1+muh_nash).*ph_nash).^(-(sigma-1)) +...
    (1-alpha).^sigma*((1+muf_nash).*pfstar_nash).^(-(sigma-1))).^(sigma/(sigma-1));
spending_nash = deltaH_nash./(deltaH_nash+deltaF_nash);

deltaFstar_nash = (alpha.^sigma*((1+mufstar_nash).*pfstar_nash).^(-sigma))./...
    (alpha.^sigma*((1+mufstar_nash).*pfstar_nash).^(-(sigma-1)) +...
    (1-alpha)^sigma*((1+muhstar_nash).*ph_nash).^(-(sigma-1))).^(sigma/(sigma-1));
deltaHstar_nash = ((1-alpha).^sigma*((1+muhstar_nash).*ph_nash).^(-sigma))./...
    (alpha.^sigma*((1+mufstar_nash).*pfstar_nash).^(-(sigma-1)) +...
    (1-alpha)^sigma*((1+muhstar_nash).*ph_nash).^(-(sigma-1))).^(sigma/(sigma-1));
spendingstar_nash = deltaFstar_nash./(deltaHstar_nash+deltaFstar_nash);


ur_nash=log(cr_nash)-kappa/2*lr_nash.^2;
urstar_nash=log(crstar_nash)-kappa/2*lrstar_nash.^2;
ui_nash=log(ci_nash)-kappa/2*li_nash.^2;
uistar_nash=log(cistar_nash)-kappa/2*listar_nash.^2;
us_nash=log(cs_nash)-kappa/2*ls_nash.^2;
usstar_nash=log(csstar_nash)-kappa/2*lsstar_nash.^2;
aggu_nash=S_nash.*us_nash + I_nash.*ui_nash + R_nash.*ur_nash;
aggustar_nash=Sstar_nash.*usstar_nash + Istar_nash.*uistar_nash + Rstar_nash.*urstar_nash;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Checks
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% tmp = [aggu_0', ones(1,1e7)*aggu_0(end)];
% sum(tmp.*(beta.^(0:(length(tmp)-1)))) - aggU_0
% 
% tmp = [aggu_nash', ones(1,1e7)*aggu_nash(end)];
% sum(tmp.*(beta.^(0:(length(tmp)-1)))) - aggU_nash
% 
% 
% tmp = [aggu_sp', ones(1,1e7)*aggu_sp(end)];
% sum(tmp.*(beta.^(0:(length(tmp)-1)))) - aggU_sp

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% plots
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ia=6;ib=4;fsize=12;
horz=HH;
time=0:1:horz-1;

f=figure;
subplot(ia,ib,1)
plot(time,S_0(1:horz),time,S_nash(1:horz),time,S_sp(1:horz),'LineWidth',2);
box off;
title('Home Susceptibles, S','FontSize',fsize);
legend('No Tax', 'Nash', 'Social Planner','Location', 'northeast');
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,2)
plot(time,I_0(1:horz),time,I_nash(1:horz),time,I_sp(1:horz),'LineWidth',2);
box off;
title('Home Infected, I','FontSize',fsize);
% ylabel('Share of Initial Population','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,3)
plot(time,R_0(1:horz),time,R_nash(1:horz),time,R_sp(1:horz),'LineWidth',2);
box off;
title('Home Recovered, R','FontSize',fsize);
% ylabel('Share of Initial Population','FontSize',fsize);
xlabel('Weeks','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,4)
plot(time,1-S_0(1:horz)-I_0(1:horz)-R_0(1:horz),...
    time,1-S_nash(1:horz)-I_nash(1:horz)-R_nash(1:horz),...
    time,1-S_sp(1:horz)-I_sp(1:horz)-R_sp(1:horz),'LineWidth',2);
box off;
title('Home Death, D','FontSize',fsize);
% ylabel('Share of Initial Population','FontSize',fsize);
xlabel('Weeks','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,5)
plot(time,Sstar_0(1:horz),time,Sstar_nash(1:horz),time,Sstar_sp(1:horz),'LineWidth',2);
box off;
title('Foreign Susceptibles, S*','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,6)
plot(time,Istar_0(1:horz),time,Istar_nash(1:horz),time,Istar_sp(1:horz),'LineWidth',2);
box off;
title('Foreign Infected, I*','FontSize',fsize);
% ylabel('Share of Initial Population','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,7)
plot(time,Rstar_0(1:horz),time,Rstar_nash(1:horz),time,Rstar_sp(1:horz),'LineWidth',2);
box off;
title('Foreign Recovered, R*','FontSize',fsize);
% ylabel('Share of Initial Population','FontSize',fsize);
xlabel('Weeks','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,8)
plot(time,1-Sstar_0(1:horz)-Istar_0(1:horz)-Rstar_0(1:horz),...
    time,1-Sstar_nash(1:horz)-Istar_nash(1:horz)-Rstar_nash(1:horz),...
    time,1-Sstar_sp(1:horz)-Istar_sp(1:horz)-Rstar_sp(1:horz),'LineWidth',2);
box off;
title('Foreign Death, D*','FontSize',fsize);
% ylabel('Share of Initial Population','FontSize',fsize);
xlabel('Weeks','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);



subplot(ia,ib,9)
plot(time,muh_0(1:horz),time,muh_nash(1:horz),time,muh_sp(1:horz),'LineWidth',2);
box off;
title('Home Tax on H Good','FontSize',fsize);
xlabel('Weeks','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);


subplot(ia,ib,10)
plot(time,(1+muf_0(1:horz))./(1+muh_0(1:horz))-1,...
    time,(1+muf_nash(1:horz))./(1+muh_nash(1:horz))-1,...
    time,(1+muf_sp(1:horz))./(1+muh_sp(1:horz))-1,'LineWidth',2);
box off;
title('Home Tariff','FontSize',fsize);
xlabel('Weeks','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);


subplot(ia,ib,11)
plot(time,mufstar_0(1:horz),time,mufstar_nash(1:horz),time,mufstar_sp(1:horz),'LineWidth',2);
box off;
title('Foreign Tax on F Good','FontSize',fsize);
xlabel('Weeks','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);


subplot(ia,ib,12)
plot(time,(1+muhstar_0(1:horz))./(1+mufstar_0(1:horz))-1,...
    time,(1+muhstar_nash(1:horz))./(1+mufstar_nash(1:horz))-1,...
    time,(1+muhstar_sp(1:horz))./(1+mufstar_sp(1:horz))-1,'LineWidth',2);
box off;
title('Foreign Tariff','FontSize',fsize);
xlabel('Weeks','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);


subplot(ia,ib,13)
plot(time,aggC_0(1:horz),time,aggC_nash(1:horz),time,aggC_sp(1:horz),'LineWidth',2);
box off;
title('Home Consumption','FontSize',fsize);
xlabel('Weeks','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,14)
plot(time,spending_0(1:horz),time,spending_nash(1:horz),time,spending_sp(1:horz),'LineWidth',2);
box off;
title('Home Consumption Share on H Good','FontSize',fsize);
xlabel('Weeks','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,15)
plot(time,aggCstar_0(1:horz),time,aggCstar_nash(1:horz),time,aggCstar_sp(1:horz),'LineWidth',2);
box off;
title('Foreign Consumption','FontSize',fsize);
xlabel('Weeks','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);

subplot(ia,ib,16)
plot(time,spendingstar_0(1:horz),time,spendingstar_nash(1:horz),time,spendingstar_sp(1:horz),'LineWidth',2);
box off;
title('Foreign Consumption Share on F Good','FontSize',fsize);
xlabel('Weeks','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);



subplot(ia,ib,17)
plot(time,aggL_0(1:horz),time,aggL_nash(1:horz),time,aggL_sp(1:horz),'LineWidth',2);
box off;
title('Home Aggregate Labor','FontSize',fsize);
xlabel('Weeks','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);
ylim([15,32]);


subplot(ia,ib,18)
plot(time,aggLstar_0(1:horz),time,aggLstar_nash(1:horz),time,aggLstar_sp(1:horz),'LineWidth',2);
box off;
title('Foreign Aggregate Labor','FontSize',fsize);
xlabel('Weeks','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);
ylim([15,32]);



subplot(ia,ib,19)
plot(time,aggu_0(1:horz),time,aggu_nash(1:horz),time,aggu_sp(1:horz),'LineWidth',2);
box off;
title('Aggregate Home Utility','FontSize',fsize);
xlabel('Weeks','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);



subplot(ia,ib,20)
plot(time,aggustar_0(1:horz),time,aggustar_nash(1:horz),time,aggustar_sp(1:horz),'LineWidth',2);
box off;
title('Aggregate Foreign Utility','FontSize',fsize);
xlabel('Weeks','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);



subplot(ia,ib,21)
plot(time,P_0(1:horz)./Pstar_0(1:horz),time,P_nash(1:horz)./Pstar_nash(1:horz),time,P_sp(1:horz)./Pstar_sp(1:horz),'LineWidth',2);
box off;
title('Real Exchange Rate','FontSize',fsize);
xlabel('Weeks','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);


subplot(ia,ib,22)
plot(time,aggL_0(1:horz)./aggLstar_0(1:horz),...
    time,aggL_nash(1:horz)./aggLstar_nash(1:horz),time,aggL_sp(1:horz)./aggLstar_sp(1:horz),'LineWidth',2);
box off;
title('Relative Labor Contribution L/L*','FontSize',fsize);
xlabel('Weeks','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);


subplot(ia,ib,23)
plot(time,aggC_0(1:horz)./aggCstar_0(1:horz),...
    time,aggC_nash(1:horz)./aggCstar_nash(1:horz),time,aggC_sp(1:horz)./aggCstar_sp(1:horz),'LineWidth',2);
box off;
title('Relative Consumption Contribution C/C*','FontSize',fsize);
xlabel('Weeks','FontSize',fsize);
set(gca,'FontSize',fsize);
xlim([0,horz]);


name = split(pwd,'/');
name = name(end-1);
name = name{1};

orient landscape

f.PaperSize = [20 16]*1.5;

Utext = ['Util: ', num2str(aggU_0+aggUstar_0 - Urss*2), ',',...
    num2str(aggU_nash+aggUstar_nash - Urss*2), ',', num2str(aggU_sp+aggUstar_sp - Urss*2)];
suptitle(['No tax vs. Nash vs. Planner, ', name, ', ', Utext]);
print(['../Figures/', job_name, '_Compare.pdf'],'-dpdf','-fillpage')
