%% Solve Nash Equilibrium Solvers for different policies 


load(['../Mat/', job_name, '_Benchmark.mat']);

load('../Mat/NoSIR_Nash.mat', 'xr', 'xrstar', 'lr', 'lrstar');
xrss1 = mean(xr+xrstar)/2;
lrss1 = mean(lr+lrstar)/2;
urss1 = log(xrss1)-kappa/2*lrss1^2; %utility recovered
Urss=1/(1-beta)*urss1;          %PV utility recovered

init_guess = 0.23*ones(1,4*n_per);

nashsse = .05;
maxiter = 100;
mintol = 1e-4;

savefile = ['../Mat/', job_name, '_Nash.mat'];

Solve_Nash;

plot1;
suptitle(['Nash ', Utext]);
print(['../Figures/', job_name, '_Nash.pdf'],'-dpdf','-fillpage')
close;