clear;
close all;

case_d = 'd0510';
% job_name=['Baseline_pi4med_C1L1B4_',case_d,'_05']
job_name=['Baseline_pi4veryveryhigh_C1L1B4_',case_d,'_05']
% job_name=['Baseline_pi410x_C1L1B4_',case_d,'_05']
% job_name=['Baseline_pi425x_C1L1B4_',case_d,'_05']
      
% job_name=['Baseline_pi4med_C1L1B4_',case_d,'_025']
% job_name=['Baseline_pi4med_C1L1B4_',case_d,'_05']
job_name=['Baseline_pi4med_C1L1B4_',case_d,'_075']



spec_label = job_name;

file_baseline = strcat('../Mat/', job_name, '_Benchmark.mat');
file_sp = strcat('../Mat/', job_name, '_Planner.mat');
file_nash = strcat('../Mat/', job_name, '_Nash.mat');



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% benchmark
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load(file_baseline);
policylength = HH;


[n_vec,fval,exitflag]=fsolve(@getErr,n_vec,opts_fsolve,...
    HH,policylength,beta,z,zstar,kappa,...
    alpha,sigma,I0,Istar0,pop0,popstar0,pi1,...
    pi2,pi3,pi4,pir,pid,pid_accel,phi,...
    Uiss,Urss,Udeath,muh,muf,muhstar,mufstar,delta_muin,delta_nuin);


[err_0,ls_0,lsstar_0,li_0,listar_0,lr_0,lrstar_0,xs_0,xsstar_0,...
    xi_0,xistar_0,xr_0,xrstar_0,chs_0,cfs_0,chsstar_0,cfsstar_0,...
    chi_0,cfi_0,chistar_0,cfistar_0,chr_0,cfr_0,chrstar_0,cfrstar_0,...
    ph_0,pfstar_0,S_0,Sstar_0,I_0,Istar_0,R_0,Rstar_0,T_0,Tstar_0,...
    aggC_0,aggCstar_0,aggL_0,aggLstar_0,g_0,gstar_0,aggU_0,aggUstar_0]...
    =getErr(n_vec,HH,policylength,beta,z,zstar,kappa,alpha,sigma,I0,Istar0,...
    pop0,popstar0,pi1,pi2,pi3,pi4,pir,pid,pid_accel,phi,Uiss,Urss,Udeath,...
    muh,muf,muhstar,mufstar,delta_muin,delta_nuin);


muh_0 = zeros(HH,1);
muf_0 = zeros(HH,1);
muhstar_0 = zeros(HH,1);
mufstar_0 = zeros(HH,1);

spending_0 = (chs_0.*S_0+chi_0.*I_0+chr_0.*R_0)./(cfs_0.*S_0+cfi_0.*I_0+cfr_0.*R_0);
spendingstar_0 = (cfsstar_0.*Sstar_0+cfistar_0.*Istar_0+cfrstar_0.*Rstar_0)./(chsstar_0.*Sstar_0+chistar_0.*Istar_0+chrstar_0.*Rstar_0);

ur_0=log(xr_0)-kappa/2*lr_0.^2;
urstar_0=log(xrstar_0)-kappa/2*lrstar_0.^2;
ui_0=log(xi_0)-kappa/2*li_0.^2;
uistar_0=log(xistar_0)-kappa/2*listar_0.^2;
us_0=log(xs_0)-kappa/2*ls_0.^2;
usstar_0=log(xsstar_0)-kappa/2*lsstar_0.^2;
aggu_0=S_0.*us_0 + I_0.*ui_0 + R_0.*ur_0;
aggustar_0=Sstar_0.*usstar_0 + Istar_0.*uistar_0 + Rstar_0.*urstar_0;

us_0=log(xs_0)-kappa/2*ls_0.^2;
ui_0=log(xi_0)-kappa/2*li_0.^2;
ur_0=log(xr_0)-kappa/2*lr_0.^2;
welfare_0 = us_0.*S_0+ui_0.*I_0+ur_0.*R_0;
welfare_cure0 = urss*(S_0+I_0+R_0);

usstar_0=log(xsstar_0)-kappa/2*lsstar_0.^2;
uistar_0=log(xistar_0)-kappa/2*listar_0.^2;
urstar_0=log(xrstar_0)-kappa/2*lrstar_0.^2;
welfarestar_0 = usstar_0.*Sstar_0+uistar_0.*Istar_0+urstar_0.*Rstar_0;
welfare_curestar0 = urss*(Sstar_0+Istar_0+Rstar_0);

sum(welfare_0.*(beta.^(0:HH-1))') + (S_0(HH)+I_0(HH)+R_0(HH)).*Urss*beta^HH - aggU_0
sum(welfarestar_0.*(beta.^(0:HH-1))') + (Sstar_0(HH)+Istar_0(HH)+Rstar_0(HH)).*Urss*beta^HH - aggUstar_0


W_0 = [sum((welfare_0-welfare_cure0).*(beta.^(0:HH-1))'),...
-sum((urss*(1-S_0-I_0-R_0)).*(beta.^(0:HH-1))') - (1-S_0(HH)-I_0(HH)-R_0(HH)).*Urss*beta^HH,...
sum((welfarestar_0-welfare_curestar0).*(beta.^(0:HH-1))'),...
-sum((urss*(1-Sstar_0-Istar_0-Rstar_0)).*(beta.^(0:HH-1))') - (1-Sstar_0(HH)-Istar_0(HH)-Rstar_0(HH)).*Urss*beta^HH];





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% social planner
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
load(file_sp);

[n_vec,fval,exitflag]=fsolve(@getErr,n_vec,opts_fsolve,...
    HH,policylength,beta,z,zstar,kappa,...
    alpha,sigma,I0,Istar0,pop0,popstar0,pi1,...
    pi2,pi3,pi4,pir,pid,pid_accel,phi,...
    Uiss,Urss,Udeath,muh,muf,muhstar,mufstar,delta_muin,delta_nuin);

[err_sp,ls_sp,lsstar_sp,li_sp,listar_sp,lr_sp,lrstar_sp,xs_sp,xsstar_sp,...
    xi_sp,xistar_sp,xr_sp,xrstar_sp,chs_sp,cfs_sp,chsstar_sp,cfsstar_sp,...
    chi_sp,cfi_sp,chistar_sp,cfistar_sp,chr_sp,cfr_sp,chrstar_sp,cfrstar_sp,...
    ph_sp,pfstar_sp,S_sp,Sstar_sp,I_sp,Istar_sp,R_sp,Rstar_sp,T_sp,Tstar_sp,...
    aggC_sp,aggCstar_sp,aggL_sp,aggLstar_sp,g_sp,gstar_sp,aggU_sp,aggUstar_sp]...
    =getErr(n_vec,HH,policylength,beta,z,zstar,kappa,alpha,sigma,I0,Istar0,...
    pop0,popstar0,pi1,pi2,pi3,pi4,pir,pid,pid_accel,phi,Uiss,Urss,Udeath,...
    muh,muf,muhstar,mufstar,delta_muin,delta_nuin);

muh_sp = muh;
muf_sp = muf;
muhstar_sp = muhstar;
mufstar_sp = mufstar;

spending_sp = (chs_sp.*S_sp+chi_sp.*I_sp+chr_sp.*R_sp)./(cfs_sp.*S_sp+cfi_sp.*I_sp+cfr_sp.*R_sp);
spendingstar_sp = (cfsstar_sp.*Sstar_sp+cfistar_sp.*Istar_sp+cfrstar_sp.*Rstar_sp)./(chsstar_sp.*Sstar_sp+chistar_sp.*Istar_sp+chrstar_sp.*Rstar_sp);

ur_sp=log(xr_sp)-kappa/2*lr_sp.^2;
urstar_sp=log(xrstar_sp)-kappa/2*lrstar_sp.^2;
ui_sp=log(xi_sp)-kappa/2*li_sp.^2;
uistar_sp=log(xistar_sp)-kappa/2*listar_sp.^2;
us_sp=log(xs_sp)-kappa/2*ls_sp.^2;
usstar_sp=log(xsstar_sp)-kappa/2*lsstar_sp.^2;
aggu_sp=S_sp.*us_sp + I_sp.*ui_sp + R_sp.*ur_sp;
aggustar_sp=Sstar_sp.*usstar_sp + Istar_sp.*uistar_sp + Rstar_sp.*urstar_sp;


us_sp=log(xs_sp)-kappa/2*ls_sp.^2;
ui_sp=log(xi_sp)-kappa/2*li_sp.^2;
ur_sp=log(xr_sp)-kappa/2*lr_sp.^2;
welfare_sp = us_sp.*S_sp+ui_sp.*I_sp+ur_sp.*R_sp;
welfare_cure0 = urss*(S_sp+I_sp+R_sp);

usstar_sp=log(xsstar_sp)-kappa/2*lsstar_sp.^2;
uistar_sp=log(xistar_sp)-kappa/2*listar_sp.^2;
urstar_sp=log(xrstar_sp)-kappa/2*lrstar_sp.^2;
welfarestar_sp = usstar_sp.*Sstar_sp+uistar_sp.*Istar_sp+urstar_sp.*Rstar_sp;
welfare_curestar0 = urss*(Sstar_sp+Istar_sp+Rstar_sp);

sum(welfare_sp.*(beta.^(0:HH-1))') + (S_sp(HH)+I_sp(HH)+R_sp(HH)).*Urss*beta^HH - aggU_sp
sum(welfarestar_sp.*(beta.^(0:HH-1))') + (Sstar_sp(HH)+Istar_sp(HH)+Rstar_sp(HH)).*Urss*beta^HH - aggUstar_sp



W_sp = [sum((welfare_sp-welfare_cure0).*(beta.^(0:HH-1))'),...
-sum((urss*(1-S_sp-I_sp-R_sp)).*(beta.^(0:HH-1))') - (1-S_sp(HH)-I_sp(HH)-R_sp(HH)).*Urss*beta^HH,...
sum((welfarestar_sp-welfare_curestar0).*(beta.^(0:HH-1))'),...
-sum((urss*(1-Sstar_sp-Istar_sp-Rstar_sp)).*(beta.^(0:HH-1))') - (1-Sstar_sp(HH)-Istar_sp(HH)-Rstar_sp(HH)).*Urss*beta^HH];



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% nash
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
load(file_nash);



[n_vec,fval,exitflag]=fsolve(@getErr,n_vec,opts_fsolve,...
    HH,policylength,beta,z,zstar,kappa,...
    alpha,sigma,I0,Istar0,pop0,popstar0,pi1,...
    pi2,pi3,pi4,pir,pid,pid_accel,phi,...
    Uiss,Urss,Udeath,muh,muf,muhstar,mufstar,delta_muin,delta_nuin);


[err_nash,ls_nash,lsstar_nash,li_nash,listar_nash,lr_nash,lrstar_nash,xs_nash,xsstar_nash,...
    xi_nash,xistar_nash,xr_nash,xrstar_nash,chs_nash,cfs_nash,chsstar_nash,cfsstar_nash,...
    chi_nash,cfi_nash,chistar_nash,cfistar_nash,chr_nash,cfr_nash,chrstar_nash,cfrstar_nash,...
    ph_nash,pfstar_nash,S_nash,Sstar_nash,I_nash,Istar_nash,R_nash,Rstar_nash,T_nash,Tstar_nash,...
    aggC_nash,aggCstar_nash,aggL_nash,aggLstar_nash,g_nash,gstar_nash,aggU_nash,aggUstar_nash]...
    =getErr(n_vec,HH,policylength,beta,z,zstar,kappa,alpha,sigma,I0,Istar0,...
    pop0,popstar0,pi1,pi2,pi3,pi4,pir,pid,pid_accel,phi,Uiss,Urss,Udeath,...
    muh,muf,muhstar,mufstar,delta_muin,delta_nuin);

muh_nash = muh;
muf_nash = muf;
muhstar_nash = muhstar;
mufstar_nash = mufstar;


spending_nash = (chs_nash.*S_nash+chi_nash.*I_nash+chr_nash.*R_nash)./(cfs_nash.*S_nash+cfi_nash.*I_nash+cfr_nash.*R_nash);
spendingstar_nash = (cfsstar_nash.*Sstar_nash+cfistar_nash.*Istar_nash+cfrstar_nash.*Rstar_nash)./(chsstar_nash.*Sstar_nash+chistar_nash.*Istar_nash+chrstar_nash.*Rstar_nash);


ur_nash=log(xr_nash)-kappa/2*lr_nash.^2;
urstar_nash=log(xrstar_nash)-kappa/2*lrstar_nash.^2;
ui_nash=log(xi_nash)-kappa/2*li_nash.^2;
uistar_nash=log(xistar_nash)-kappa/2*listar_nash.^2;
us_nash=log(xs_nash)-kappa/2*ls_nash.^2;
usstar_nash=log(xsstar_nash)-kappa/2*lsstar_nash.^2;
aggu_nash=S_nash.*us_nash + I_nash.*ui_nash + R_nash.*ur_nash;
aggustar_nash=Sstar_nash.*usstar_nash + Istar_nash.*uistar_nash + Rstar_nash.*urstar_nash;


us_nash=log(xs_nash)-kappa/2*ls_nash.^2;
ui_nash=log(xi_nash)-kappa/2*li_nash.^2;
ur_nash=log(xr_nash)-kappa/2*lr_nash.^2;
welfare_nash = us_nash.*S_nash+ui_nash.*I_nash+ur_nash.*R_nash;
welfare_cure0 = urss*(S_nash+I_nash+R_nash);

usstar_nash=log(xsstar_nash)-kappa/2*lsstar_nash.^2;
uistar_nash=log(xistar_nash)-kappa/2*listar_nash.^2;
urstar_nash=log(xrstar_nash)-kappa/2*lrstar_nash.^2;
welfarestar_nash = usstar_nash.*Sstar_nash+uistar_nash.*Istar_nash+urstar_nash.*Rstar_nash;
welfare_curestar0 = urss*(Sstar_nash+Istar_nash+Rstar_nash);

sum(welfare_nash.*(beta.^(0:HH-1))') + (S_nash(HH)+I_nash(HH)+R_nash(HH)).*Urss*beta^HH - aggU_nash
sum(welfarestar_nash.*(beta.^(0:HH-1))') + (Sstar_nash(HH)+Istar_nash(HH)+Rstar_nash(HH)).*Urss*beta^HH - aggUstar_nash




W_nash = [sum((welfare_nash-welfare_cure0).*(beta.^(0:HH-1))') + ...
    (urss1-urss)/(1-beta)*beta^HH,...
-sum((urss*(1-S_nash-I_nash-R_nash)).*(beta.^(0:HH-1))') - (1-S_nash(HH)-I_nash(HH)-R_nash(HH)).*Urss*beta^HH,...
sum((welfarestar_nash-welfare_curestar0).*(beta.^(0:HH-1))') + ...
    (urss1-urss)/(1-beta)*beta^HH,...
-sum((urss*(1-Sstar_nash-Istar_nash-Rstar_nash)).*(beta.^(0:HH-1))') - (1-Sstar_nash(HH)-Istar_nash(HH)-Rstar_nash(HH)).*Urss*beta^HH];




['Country A Util: ', num2str(aggU_0 - Urss), ',',...
    num2str(aggU_nash - Urss), ',', num2str(aggU_sp - Urss)]
['Country B Util: ', num2str(aggUstar_0 - Urss), ',',...
    num2str(aggUstar_nash - Urss), ',', num2str(aggUstar_sp - Urss)]
['Total Util: ', num2str(aggU_0+aggUstar_0 - Urss*2), ',',...
    num2str(aggU_nash+aggUstar_nash - Urss*2), ',', num2str(aggU_sp+aggUstar_sp - Urss*2)]


W=[W_0; W_nash; W_sp];
W = [W(:,1)+W(:,2),W(:,1:2),W(:,3)+W(:,4),W(:,3:4)];
W = [W; W(3,:)-W(2,:)];



% savefile = ['../Tables/Welfare_', job_name, '.mat'];
% save(savefile, "W")

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Table 1
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

m = zeros(8,3);

[tmp1, tmp2] = max(I_0);
m(1,1) = tmp2;
m(3,1) = tmp1*1e3;
[tmp1, tmp2] = max(Istar_0);
m(2,1) = tmp2;
m(4,1) = tmp1*1e3;

[tmp1, tmp2] = max(I_nash);
m(1,2) = tmp2;
m(3,2) = tmp1*1e3;
[tmp1, tmp2] = max(Istar_nash);
m(2,2) = tmp2;
m(4,2) = tmp1*1e3;

[tmp1, tmp2] = max(I_sp);
m(1,3) = tmp2;
m(3,3) = tmp1*1e3;
[tmp1, tmp2] = max(Istar_sp);
m(2,3) = tmp2;
m(4,3) = tmp1*1e3;

threshold = 1e-4;
m(5,1) = find(I_0>threshold, 1, 'last');
m(6,1) = find(Istar_0>threshold, 1, 'last');

m(5,2) = find(I_nash>threshold, 1, 'last');
m(6,2) = find(Istar_nash>threshold, 1, 'last');

m(5,3) = find(I_sp>threshold, 1, 'last');
m(6,3) = find(Istar_sp>threshold, 1, 'last');

m(7,1) = max(1-S_0-I_0-R_0)*1e3;
m(8,1) = max(1-Sstar_0-Istar_0-Rstar_0)*1e3;

m(7,2) = max(1-S_nash-I_nash-R_nash)*1e3;
m(8,2) = max(1-Sstar_nash-Istar_nash-Rstar_nash)*1e3;

m(7,3) = max(1-S_sp-I_sp-R_sp)*1e3;
m(8,3) = max(1-Sstar_sp-Istar_sp-Rstar_sp)*1e3;

W_health = m;


