function [neg_aggU,n_vec1]=getU_NoTariff(mu1,n_vec_guess,opts_fsolve,...
    HH,policylength,granularity,beta,z,zstar,...
    kappa,alpha,sigma,I0,Istar0,pop0,popstar0,...
    pi1,pi2,pi3,pi4,pir,pid,pid_accel,...
    phi,Uiss,Urss,Udeath,...
    delta_muin,delta_nuin,...
    welfaretype)

% Welfare type is a flag for 1. home, 2. foreign, 3. aggregate

% construct policies given mu1
muh = zeros(HH,1);
muf = zeros(HH,1);
muhstar = zeros(HH,1);
mufstar = zeros(HH,1);

% Policy is constant for granularity weeks over the total policy length
n_per = policylength/granularity;

% Policies are Equal
muh(1:policylength) = kron(mu1(1:n_per),ones(1,granularity));
muf(1:policylength) = kron(mu1(1:n_per),ones(1,granularity));
muhstar(1:policylength) = kron(mu1((n_per+1):(2*n_per)),ones(1,granularity));
mufstar(1:policylength) = kron(mu1((n_per+1):(2*n_per)),ones(1,granularity));

% % create persistent variable
persistent guess_n n_vec
if isempty(guess_n)==1
    guess_n=n_vec_guess;
else
    guess_n=n_vec;
end;
% guess_n = n_vec_guess;

try
    [n_vec,fval,exitflag]=fsolve(@getErr,guess_n,opts_fsolve,...
        HH,policylength,beta,z,zstar,kappa,...
        alpha,sigma,I0,Istar0,pop0,popstar0,pi1,...
        pi2,pi3,pi4,pir,pid,pid_accel,phi,...
        Uiss,Urss,Udeath,muh,muf,muhstar,mufstar,delta_muin,delta_nuin);
    
    if (exitflag < 1)
        error('Fsolve could not solve the model');
    end
    
    [err,ls,lsstar,li,listar,lr,lrstar,xs,xsstar,xi,xistar,xr,xrstar,chs,cfs,chsstar,cfsstar,chi,cfi,chistar,cfistar,chr,cfr,chrstar,cfrstar,...
     ph,pfstar,S,Sstar,I,Istar,R,Rstar,T,Tstar,aggC,aggCstar,aggL,aggLstar,g,gstar,aggU,aggUstar] = ... 
        getErr(n_vec,...
               HH,policylength,beta,z,zstar,kappa,...
               alpha,sigma,I0,Istar0,pop0,popstar0,pi1,...
               pi2,pi3,pi4,pir,pid,pid_accel,phi,...
               Uiss,Urss,Udeath,muh,muf,muhstar,mufstar,delta_muin,delta_nuin);
        
catch
    % exitflag
    aggU=-1e10;
    aggUstar=-1e10;
    guess_n=[];
end

switch welfaretype
    case 1
        neg_aggU = -(aggU-Urss);
    case 2
        neg_aggU = -(aggUstar-Urss);
    case 3
        neg_aggU = -aggU-aggUstar+Urss*2;
end

n_vec1 = n_vec;

end
